require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to test the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator. If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails. There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.

RSpec.describe '/profils', type: :request do
  let(:valid_attributes) { {profil_name: 'author', name: 'Autheur'} }
  let(:invalid_attributes) { {profil_name: 'author', name: nil} }

  let(:user) { FactoryBot.create(:user) }

  before :each do
    sign_in user
  end

  describe 'GET /index' do
    it 'renders a successful response' do
      Profil.create! valid_attributes
      get profils_url
      expect(response).to be_successful
    end
  end

  # describe 'GET /show' do
  #   it 'renders a successful response' do
  #     profil = Profil.create! valid_attributes
  #     get profil_url(profil)
  #     expect(response).to be_successful
  #   end
  # end

  describe 'GET /new' do
    it 'renders a successful response' do
      get new_profil_url
      expect(response).to be_successful
    end
  end

  describe 'GET /edit' do
    it 'render a successful response' do
      profil = Profil.create! valid_attributes
      get edit_profil_url(profil)
      expect(response).to be_successful
    end
  end

  describe 'POST /create' do
    context 'with valid parameters' do
      it 'creates a new Profil' do
        expect {
          post profils_url, params: { profil: valid_attributes }
        }.to change(Profil, :count).by(1)
      end

      it 'redirects to the created profil' do
        post profils_url, params: { profil: valid_attributes }
        expect(response).to redirect_to(profils_url)
      end
    end

    context 'with invalid parameters' do
      it 'does not create a new Profil' do
        expect {
          post profils_url, params: { profil: invalid_attributes }
        }.to change(Profil, :count).by(0)
      end

      it 'renders a successful response (i.e. to display the new template)' do
        post profils_url, params: { profil: invalid_attributes }
        expect(response).to be_successful
      end
    end
  end

  describe 'PATCH /update' do
    context 'with valid parameters' do
      let(:new_attributes) { {profil_name: 'pilote', name: 'Pilote'} }

      it 'updates the requested profil' do
        profil = Profil.create! valid_attributes
        patch profil_url(profil), params: { profil: new_attributes }
        profil.reload
        # binding.pry
        expect(profil.profil_name).to eq 'pilote'
        expect(profil.name).to eq 'Pilote'
      end

      it 'redirects to the profil' do
        profil = Profil.create! valid_attributes
        patch profil_url(profil), params: { profil: new_attributes }
        profil.reload
        expect(response).to redirect_to(profils_url)
      end
    end

    context 'with invalid parameters' do
      it 'renders a successful response (i.e. to display the edit template)' do
        profil = Profil.create! valid_attributes
        patch profil_url(profil), params: { profil: invalid_attributes }
        expect(response).to be_successful
      end
    end
  end

  describe 'DELETE /destroy' do
    it 'destroys the requested profil' do
      profil = Profil.create! valid_attributes
      expect {
        delete profil_url(profil)
      }.to change(Profil, :count).by(-1)
    end

    it 'redirects to the profils list' do
      profil = Profil.create! valid_attributes
      delete profil_url(profil)
      expect(response).to redirect_to(profils_url)
    end
  end
end
